##################################################

def digital_sum(n):
    '''Restituisce la somma delle cifre che compongno il numero n'''
    if n<10: return n
    return n%10 + digital_sum(n//10)

# >>> digital_sum(27)
# 9
# >>> digital_sum(1111)
# 4

##################################################
def somma(lista):
    '''restituisce una tupla, la prima componente contiene il numero di interi
    strettamente positivi in lista, la seconda contiene la somma dei numeri 
    strettamente negativi in lista'''
    if lista == []: return (0,0)
    a, b = somma(lista[1:])
    if lista[0] > 0: return (a + 1, b)
    elif lista[0] < 0: return (a, b + 1)
    return (a,b)


# >>> somma([3,0,-1,2,4,-1])
# (3, 2)
# >>> somma([0,0,2,0,1])  
# (2, 0)

####################################################

def es(n):
     '''la funzione es(n) restituisce un dizionario le cui chiavi sono interi.
     Attributo della chiave x e' il numero di modi in cui il lancio di n 
     dadi distinti puo'
     produrre somma x. Nel dizionario devono comparire  solo le chiavi con attributo
     strettamente positivo.
     Ad esempio:
     es(1) restituisce il dizionario {1:1,2:1,3:1,4:1,5:1,6:1}
     '''
     if n==1: return {1:1,2:1,3:1,4:1,5:1,6:1}
     d1=es(n-1)
     d={}
     for i in range(1,7):
         for x in d1:
             if x+i in d: d[x+i]+=d1[x]
             else: d[x+i]=d1[x]
     return d

# >>> es(1) 
# {1:1,2:1,3:1,4:1,5:1,6:1}

# es(2)
# {2: 1, 3: 2, 4: 3, 5: 4, 6: 5, 7: 6, 8: 5, 9: 4, 10: 3, 11: 2, 12: 1}

# >>> es(3)
# {3: 1, 4: 3, 5: 6, 6: 10, 7: 15, 8: 21, 9: 25, 10: 27, 11: 27, 12: 25, 
# 13: 21, 14: 15, 15: 10, 16: 6, 17: 3, 18: 1}
